//TODO: //-nepresuvaj ked je krajina okolo ktora na teba moze utocit
//      -pripocitaj mountains
//      -utoc prioritne na krajinu ktora neni neutralna
//      -zatial done - ak neutocim, presunut vojakov z krajnej krajiny do "bojovnej"
//      -ak je na mape silny hrac, tak sa ho pokus rozdelit
//      -davaj pozor, aby krajina nemala prilis dlhe hranice

#include <iostream>
#include <vector>
#include "Engine.h"
#include <fstream>

#include "kniznica.cpp"

extern void wPrihlasenie(const char*);
extern int wMojeID();

extern int wPocetKrajin();
extern int wPocetMojichKrajin();
extern int wDalsiaMojaKrajina();

extern int wPeniaze();
extern int wSusedia(int krajinaA, int krajinaB);
extern int wHornatost(int krajina);
extern int wProsperita(int krajina);
extern int wMajitel(int krajina);
extern int wVojsko(int krajina);

extern bool wNajmi(int kde, int kolko);
extern void wNeutoc();
extern bool wZautoc(int odkial, int kam, int kolko);

extern bool wSuNovinky();
extern int wDalsiaNovinka();

Engine::Engine()
{

}

Engine::~Engine()
{

}
KreativnyEngine::KreativnyEngine()
{
    m_turns = 0;
}

KreativnyEngine::~KreativnyEngine()
{
    debug.close();
}

void KreativnyEngine::logInPlayer()
{
    wPrihlasenie("Kreativny nazov");
    debug.open("debug");
    debug << "[SYS] Logged in." << std::endl;
}

bool KreativnyEngine::hasEnemy(int country)
{
    for(unsigned int i = 0; i<countries[country].neighbours.size(); i++)
    {
        int owner1 = wMajitel(country+1);
        int owner2 = wMajitel(countries[country].neighbours[i]+1);

        if(owner1 != owner2 && owner2 != 0)
        {
            return true;
        }
    }

    return false;
}

int KreativnyEngine::getPower(int country)
{
    int out = countries[country].army;
    return out;
}

float KreativnyEngine::getMountains(int country)
{
    float out = 1.0f;
    for(int i = 0; i<countries[country].mountains; i++)
    {
        out *= 0.80f;
    }

    return out;
}

int KreativnyEngine::weakestEnemyNeighbour(int country)
{
    int weakest = 100000;
    int id = -1;
    for(unsigned int i = 0; i<countries[country].neighbours.size(); i++)
    {
        if(wMajitel(countries[country].neighbours[i]+1) != wMojeID())
        {
            int force = getPower(countries[country].neighbours[i]);
            if(force < weakest)
            {
                weakest = countries[countries[country].neighbours[i]].army;
                id = countries[country].neighbours[i];
            }
        }
    }
    return id;
}


int KreativnyEngine::strongestEnemy(int country)
{
    int strongest = -1;
    int id = -1;
    for(unsigned int i = 0; i<countries[country].neighbours.size(); i++)
    {
        if(wMajitel(countries[country].neighbours[i]+1) != wMojeID() && wMajitel(countries[country].neighbours[i]+1) != 0)
        {
            int force = getPower(countries[country].neighbours[i]);
            if(force > strongest)
            {
                strongest = countries[countries[country].neighbours[i]].army;
                id = countries[country].neighbours[i];
            }
        }
    }
    return id;
}

bool KreativnyEngine::hasSingleEnemy(int country)
{
    bool enemy = false;
    for(unsigned int i =0; i<countries[country].neighbours.size(); i++)
    {
        int owner1 = wMajitel(countries[country].neighbours[i]+1);
        int owner2 = wMojeID();

        if(owner1 != owner2 && owner1 != 0)
        {
            if(!enemy)
                enemy = true;
            else
                return false;
        }
    }


    debug << "Has single enemy returned: true" << std::endl;
    return true;
}

int KreativnyEngine::getSingleEnemy(int country)
{
    int out = -1;

    for(unsigned int i = 0; i<countries[country].neighbours.size(); i++)
    {
        int owner = wMajitel(countries[country].neighbours[i]+1);
        //debug << "[GSE]: owner: " << owner << " : " << wMojeID() << std::endl;
        if(owner != wMojeID() && owner != 0)
        {
            out = i;
        }
    }

    return out;
}

/*bool KreativnyEngine::singleEnemy(int& country)
{
    bool one = false;
    int tc = -1;
    for(int i = 0; i<wPocetKrajin(); i++)
    {
        int owner = wMajitel(i+1);
        if(owner != wMojeID() && owner != 0)
        {
            if(one == true)
                return false;
            else
            {
                one = true;
                tc = i;
            }
        }
    }

    country = tc;
    return true;
}*/


bool KreativnyEngine::moveSoldiersToFrontLine()
{
    for(int j = 0; j<wPocetMojichKrajin(); j++)
    {
        int currentCountry = wDalsiaMojaKrajina() - 1;
        if(hasEnemy(currentCountry) == false && wVojsko(currentCountry+1) != 0)
        {
            for(unsigned int i = 0; i<countries[currentCountry].neighbours.size(); i++)
            {
                if(hasEnemy(countries[currentCountry].neighbours[i]))
                {

                    debug << "Presuvanie vojakov z: " << currentCountry+1 << " do:" << countries[currentCountry].neighbours[i]+1 << " s vojskom: " << wVojsko(currentCountry+1) << std::endl;
                    wZautoc(currentCountry+1, countries[currentCountry].neighbours[i]+1, wVojsko(currentCountry+1));
                    return true;
                }
            }
        }
    }
    //nikoho som nepresuval
    return false;
}

void KreativnyEngine::loadData()
{
    debug << "[FCL] loadData()" << std::endl;

    countries.resize(wPocetKrajin());
    for(unsigned int j = 0; j<countries.size(); j++)
    {
        countries[j].army = wVojsko(j+1);
        countries[j].mountains = wHornatost(j+1);
        countries[j].owner = wMajitel(j+1) + 1;

        for(int i = 0; i<wPocetKrajin(); i++)
        {
            if(wSusedia(j+1, i+1))
            {
                countries[j].neighbours.push_back(i);
            }
        }
    }
}

void KreativnyEngine::reinforceCountries()
{
    debug << "[FCL] reinforceCountries()" << std::endl;
    for(int j = 0; j<wPocetMojichKrajin(); j++)
    {
        int currentCountry = wDalsiaMojaKrajina() - 1;
        for(unsigned int i = 0; i<countries[currentCountry].neighbours.size(); i++)
        {
            float myForce = countries[currentCountry].army;
            float enemyForce = countries[countries[currentCountry].neighbours[i]].army;

            int owner1 = wMajitel(countries[currentCountry].neighbours[i]+1);
            int owner2 = wMojeID();//wMajitel(currentCountry+1);

            if(owner1 != owner2 && owner1 != 0)
            {
                if(myForce < 2*enemyForce)
                {
                    //debug << "[HIR] Country: " << currentCountry+1 << std::endl;
                    if (wPeniaze() >= 2*enemyForce - myForce)
                    {
                        wNajmi(currentCountry+1, 2*enemyForce - myForce);
                        //debug << "[HIR] Amount: " << enemyForce-myForce << std::endl;
                    }
                    else if (wPeniaze())
                    {
                        wNajmi(currentCountry+1, wPeniaze());
                        //debug << "[HIR] Amount: " << wPeniaze() << std::endl;
                    }
                }
            }
        }
    }

    /*for(int j = 0; j<wPocetMojichKrajin(); j++)
    {
        int currentCountry = wDalsiaMojaKrajina() - 1;
        for(unsigned int i = 0; i<countries[currentCountry].neighbours.size(); i++)
        {
            float myForce = countries[currentCountry].army;
            float enemyForce = countries[countries[currentCountry].neighbours[i]].army;

            int owner1 = wMajitel(countries[currentCountry].neighbours[i]+1);
            int owner2 = wMojeID();//wMajitel(currentCountry+1);

            if(owner1 != owner2 && owner1 != 0)
            {
                if(myForce < 3*enemyForce)
                {
                    //debug << "[HIR] Country: " << currentCountry+1 << std::endl;
                    if (wPeniaze() >= (3*enemyForce - myForce))
                    {
                        wNajmi(currentCountry+1, 3*enemyForce-myForce);
                        //debug << "[HIR] Amount: " << enemyForce-myForce << std::endl;
                    }
                    else if (wPeniaze())
                    {
                        wNajmi(currentCountry+1, wPeniaze());
                        //debug << "[HIR] Amount: " << wPeniaze() << std::endl;
                    }
                }
            }
        }
    }*/

    bool aroundNeutrals = false;
    for(int j = 0; j<wPocetMojichKrajin(); j++)
    {
        int currentCountry = wDalsiaMojaKrajina() - 1;
        for(unsigned int i = 0; i<countries[currentCountry].neighbours.size(); i++)
        {
            if(wMajitel(countries[currentCountry].neighbours[i]+1) != 0 || wMajitel(countries[currentCountry].neighbours[i]+1) != wMojeID())
            {
                aroundNeutrals = true;
                j = wPocetMojichKrajin();
                break;
            }
        }
    }
    if(!aroundNeutrals)
    {
        debug << "All my countries have no enemies." << std::endl;
        for(int j = 0; j<wPocetMojichKrajin(); j++)
        {
            int currentCountry = wDalsiaMojaKrajina() - 1;
            for(unsigned int i = 0; i<countries[currentCountry].neighbours.size(); i++)
            {
                if(wMajitel(countries[currentCountry].neighbours[i]+1) == 0)
                    wNajmi(currentCountry+1, wPeniaze());
            }
        }
    }
    else
    {
        while(wPeniaze())
        {
            for(int j = 0; j<wPocetMojichKrajin(); j++)
            {
                int currentCountry = wDalsiaMojaKrajina() - 1;
                bool hasEnemy = false;
                for(unsigned int i = 0; i<countries[currentCountry].neighbours.size(); i++)
                {
                    if(wMajitel(countries[currentCountry].neighbours[i]+1) != wMojeID())
                    {
                        hasEnemy = true;
                        break;
                    }
                }

                if(hasEnemy)
                    wNajmi(currentCountry+1, 1);
            }
        }
    }
}

void KreativnyEngine::decideWhatToDo()
{
    debug << "[FCL] decideWhatToDo()" << std::endl;

    if(m_turns < 3)
    {
        bool attacked = false;
        for(int j = 0; j<wPocetMojichKrajin(); j++)
        {
            int currentCountry = wDalsiaMojaKrajina() - 1;
            for(unsigned int i =0; i<countries[currentCountry].neighbours.size(); i++)
            {
                float enemyForce = countries[countries[currentCountry].neighbours[i]].army;
                float myForce = countries[currentCountry].army * getMountains(countries[currentCountry].neighbours[i]);

                int strongestForce;
                if(strongestEnemy(currentCountry) > 0)
                {
                    strongestForce = wVojsko(strongestEnemy(currentCountry)+1);
                }
                else
                    strongestForce = 0;


                if(myForce > (enemyForce + enemyForce/2) &&  strongestForce < myForce-enemyForce )
                {
                    int owner1 = wMajitel(countries[currentCountry].neighbours[i]+1);
                    int owner2 = wMojeID();//wMajitel(currentCountry+1);

                    if( owner1 != owner2)
                    {
                        debug << "[ATK] target: " << owner1 << std::endl;
                        debug << "[ATK] my id:" << owner2 << std::endl;
                        debug << "[ATK] zautocil som!";
                        int change = wVojsko(currentCountry+1) - (countries[countries[currentCountry].neighbours[i]].army + countries[countries[currentCountry].neighbours[i]].army/2);
                        int forceSize = wVojsko(currentCountry+1) - change;
                        if(forceSize == 0)
                        {
                            forceSize = wVojsko(currentCountry+1);
                        }
                        if(!hasEnemy(currentCountry))
                        {
                            forceSize = wVojsko(currentCountry+1);
                        }

                        if(myForce < 5*enemyForce)
                        {
                            wZautoc(currentCountry+1, countries[currentCountry].neighbours[i]+1, forceSize);
                        }
                        else
                        {
                            forceSize = wVojsko(currentCountry+1)/5*3;
                            wZautoc(currentCountry+1, countries[currentCountry].neighbours[i]+1, forceSize);
                        }

                        j = wPocetMojichKrajin();
                        attacked = true;
                        break;
                    }
                }
            }
        }

        if(attacked == false)
        {
            if(!moveSoldiersToFrontLine())
            {
                wNeutoc();
            }
        }
    }
    else// if(m_turns > 4)
    {
        bool attacked = false;
        for(int j = 0; j<wPocetMojichKrajin(); j++)
        {
            int currentCountry = wDalsiaMojaKrajina() - 1;
            if(hasSingleEnemy(currentCountry) && getSingleEnemy(currentCountry) > 0)
            {
                debug << "Inside hasSingleEnemy" << std::endl << " {" << std::endl;
                int target = getSingleEnemy(currentCountry);

                float enemyForce = countries[target].army;
                float myForce = countries[currentCountry].army;

                if(myForce > enemyForce)
                {
                    //int owner1 = wMajitel(countries[currentCountry].neighbours[i]+1);
                    int owner2 = wMojeID();//wMajitel(currentCountry+1);

                    if( target+1 != owner2)
                    {
                        debug << "[ATK] target: " << target << std::endl;
                        debug << "[ATK] my id:" << owner2 << std::endl;
                        debug << "[ATK] zautocil som!";

                        wZautoc(currentCountry+1, target+1, wVojsko(currentCountry+1));

                        attacked = true;
                        break;
                        debug << "}" << std::endl;
                    }
                }
            }
            else
            {
                for(unsigned int i =0; i<countries[currentCountry].neighbours.size(); i++)
                {
                    float enemyForce = countries[countries[currentCountry].neighbours[i]].army;
                    float myForce = countries[currentCountry].army;

                        //debug << "Passed hasSingleenemy if()" << std::endl;
                        if(myForce > 2*enemyForce)
                        {
                            int owner1 = wMajitel(countries[currentCountry].neighbours[i]+1);
                            int owner2 = wMojeID();//wMajitel(currentCountry+1);

                            //debug << "[ATK] target: " << owner1 << std::endl;
                            //debug << "[ATK] my id:" << owner2 << std::endl;
                            if( owner1 != owner2)
                            {
                                debug << "[ATK] zautocil som!";
                                if(myForce < 5*enemyForce)
                                {
                                    wZautoc(currentCountry+1, countries[currentCountry].neighbours[i]+1, 2*wVojsko(currentCountry+1)/3);
                                }
                                else
                                {
                                    int forceSize = wVojsko(currentCountry+1)/5*3;
                                    wZautoc(currentCountry+1, countries[currentCountry].neighbours[i]+1, forceSize);
                                }

                                j = wPocetMojichKrajin();
                                attacked = true;
                                break;
                            }
                        }
                        /*else if(wMajitel(countries[currentCountry].neighbours[i]+1) == 0 && myForce > 2*enemyForce)
                        {
                            int owner1 = wMajitel(countries[currentCountry].neighbours[i]+1);
                            int owner2 = wMojeID();//wMajitel(currentCountry+1);

                            debug << "[ATK] target: " << owner1 << std::endl;
                            debug << "[ATK] my id:" << owner2 << std::endl;
                            if( owner1 != owner2)
                            {
                                debug << "[ATK] zautocil som!";
                                if(myForce < 5*enemyForce)
                                {
                                    wZautoc(currentCountry+1, countries[currentCountry].neighbours[i]+1, 2*(wVojsko(currentCountry+1)/3));
                                }
                                else
                                {
                                    int forceSize = wVojsko(currentCountry+1)/5*3;
                                    wZautoc(currentCountry+1, countries[currentCountry].neighbours[i]+1, forceSize);
                                }

                                j = wPocetMojichKrajin();
                                attacked = true;
                                break;
                            }
                        }*/

                }
            }
        }

        if(attacked == false)
        {
            if(!moveSoldiersToFrontLine())
            {
                wNeutoc();
            }
        }

    }
}

void KreativnyEngine::runGame()
{
    while(1)
    {
        //engineLogic
        loadData();

        reinforceCountries();

        decideWhatToDo();

        m_turns++;
    }
}


/*int weakestEnemy = weakestEnemyNeighbour(currentCountry);
if( weakestEnemy > 0)   //neni to moja krajina
{
    int myForce = getPower(currentCountry);
    int enemyForce = getPower(weakestEnemy);

    if(myForce >= enemyForce + enemyForce/2)
    {
        debug << "[ATK] target: " << weakestEnemy << std::endl;
        debug << "[ATK] my id:" << wMojeID() << std::endl;
        debug << "[ATK] zautocil som!";
        int change = wVojsko(currentCountry+1) - countries[weakestEnemy].army - (countries[weakestEnemy].army/2);
        int forceSize = wVojsko(currentCountry+1) - change;
        if(forceSize == 0)
        {
            forceSize = wVojsko(currentCountry+1);
        }
        wZautoc(currentCountry+1, weakestEnemy+1, forceSize);

        attacked = true;
        break;
    }
}*/
