#include "Country.h"
#include <fstream>

#ifndef ENGINE_H_INCLUDED
#define ENGINE_H_INCLUDED

class Engine
{
public:
    Engine();
    virtual ~Engine();

    virtual void logInPlayer() = 0;
    virtual void runGame() = 0;
protected:
private:
};

class KreativnyEngine : public Engine
{
public:
    KreativnyEngine();
    ~KreativnyEngine();

    void logInPlayer();
    void runGame();
private:
    void loadData();
    void reinforceCountries();
    void decideWhatToDo();

private:
    bool moveSoldiersToFrontLine();

private:
    bool hasEnemy(int country);
    int weakestEnemyNeighbour(int country);
    int strongestEnemy(int country);
    int getSingleEnemy(int country);
    bool hasSingleEnemy(int country);
    int getPower(int country);
    float getMountains(int country);
    bool singleEnemy(int& country);

private:
    int m_turns;
    std::vector<Country> countries;
    std::ofstream debug;
};

#endif // ENGINE_H_INCLUDED
