/*********************************************/
/*          Proboj KSP Jeseň 2011            */
/* Wrapper pre komunikáciu hráča so serverom */
/*                                           */
/* Nepoužitie tohoto wrappera pravdepodobne  */
/* povedie k nesprávnej komunikácii a teda   */
/* aj nefunkčnosti hráča                     */
/*********************************************/

#include <cstdio>
#include <cstdlib>
#include <vector>
#include <unistd.h>

using namespace std;

int _w_money;
int _w_countries;
int _w_my_countries;
int _w_my_id;
int _w_pointer;
int _w_news_pointer = 0;
bool **_w_adj_matrix;
vector<int> _w_terrains;
vector<int> _w_earnings;
vector<int> _w_owners;
vector<int> _w_strengths;
vector<int> _w_news;

void _w_waitForNews() {
    int _w_source, _w_target, _w_amount, _w_survivors;
    
    _w_news.clear();
    _w_news_pointer = 0;
    
    while (scanf("%d", &_w_money), _w_money < 0)
        if (_w_money == -3) {
            scanf("%d %d", &_w_source, &_w_amount);
            _w_strengths[--_w_source] += _w_amount;
        } else {
            scanf("%d %d %d %d", &_w_source, &_w_target, &_w_amount, &_w_survivors);
            --_w_source; --_w_target;
        
            _w_strengths[_w_source] -= _w_amount;
            _w_strengths[_w_target] = _w_survivors;
        
            if (_w_owners[_w_target] == _w_my_id)
                _w_news.push_back(_w_target + 1);
            
            if (_w_money == -1)
                _w_owners[_w_target] = _w_owners[_w_source];
        }

    scanf("%d", &_w_my_countries);
    if (!_w_my_countries) exit(0);
}


void wPrihlasenie(const char* meno) {
    FILE* f;
    
    // zisti svoje cislo
    scanf("%d", &_w_my_id);
    char aux[50];
    sprintf(aux, "../prepared/player%d/", _w_my_id);
    chdir(aux);
    
    // nacitaj mapu
    f = fopen("mapa", "r");
    fscanf(f, "%d", &_w_countries);
    
    _w_adj_matrix = (bool**)malloc(_w_countries * sizeof(bool*));
    for (int i = 0; i < _w_countries; i++)
        _w_adj_matrix[i] = (bool*)malloc(_w_countries * sizeof(bool));
    
    for (int i = 0; i < _w_countries; i++)
        for (int j = 0; j < _w_countries; j++)
            _w_adj_matrix[i][j] = false;
    
    for (int i = 0; i < _w_countries; i++) {
        int _w_neighbour_count;
        fscanf(f, "%d", &_w_neighbour_count);
        
        for (int j = 0; j < _w_neighbour_count; j++) {
            int x;
            
            fscanf(f, "%d", &x); --x;
            _w_adj_matrix[i][x] = _w_adj_matrix[x][i] = true;
        }
    }

    fclose(f);
    
    // nacitaj teren
    f = fopen("teren", "r");
    
    for (int i = 0; i < _w_countries; i++) {
        int x;
        
        fscanf(f, "%d", &x);
        _w_terrains.push_back(x);
        fscanf(f, "%d", &x);
        _w_earnings.push_back(x);
    }
    
    fclose(f);
    
    // nacitaj vojska
    f = fopen("vojska", "r");
    
    for (int i = 0; i < _w_countries; i++) {
        int x;
        
        fscanf(f, "%d", &x);
        _w_owners.push_back(x);
        fscanf(f, "%d", &x);
        _w_strengths.push_back(x);
    }
    
    fclose(f);
    
    // prihlas sa do hry
    
    printf("%s\n", meno);
    fflush(stdout);
    
    _w_waitForNews();
}

int wMojeID() {
    return _w_my_id;
}

int wSusedia(int _w_country_A, int _w_country_B) {
    return _w_adj_matrix[--_w_country_A][--_w_country_B];
}

int wHornatost(int _w_country) {
    return _w_terrains[--_w_country];
}

int wProsperita(int _w_country) {
    return _w_earnings[--_w_country];
}

int wMajitel(int _w_country) {
    return _w_owners[--_w_country];
}

int wVojsko(int _w_country) {
    return _w_strengths[--_w_country];
}

int wPeniaze() {
    return _w_money;
}

int wPocetKrajin() {
    return _w_countries;
}

int wPocetMojichKrajin() {
    return _w_my_countries;
}

int wDalsiaMojaKrajina() {
    while (1) {
        while (_w_pointer < _w_countries && _w_owners[_w_pointer] != _w_my_id)
            ++_w_pointer;
        
        if (_w_pointer < _w_countries) return (++_w_pointer);
        _w_pointer = 0;
    }
}

bool wNajmi(int _w_where, int _w_count) {
    if (!_w_where) return false;
    
    printf("%d %d\n", _w_where, _w_count);
    fflush(stdout);
    
    int _w_ret = 0;
    scanf("%d", &_w_ret);
    
    if (_w_ret) {
        _w_money -= _w_count;
        _w_strengths[--_w_where] += _w_count;
    }
    
    return (_w_ret == 1);
}

void wNeutoc() {
    puts("0 0 0\n");
    fflush(stdout);
    
    _w_waitForNews();
}

bool wZautoc(int _w_source, int _w_target, int _w_amount) {
    printf("0 0 1 %d %d %d\n", _w_source, _w_target, _w_amount);
    fflush(stdout);
    
    int _w_result, _w_survivors;
    scanf("%d %d", &_w_result, &_w_survivors);
    
    // _w_result: 0 (no fight - wrong command), 1 (lost fight), 2 (won fight)
    
    if (_w_result) {
        _w_strengths[_w_source - 1] -= _w_amount;
        _w_strengths[_w_target - 1] = _w_survivors;
    }
    
    if (_w_result == 2)
        _w_owners[_w_target - 1] = _w_my_id;
    
    _w_waitForNews();
    
    return (_w_result == 2);
}

bool wSuNovinky() {
    return (_w_news_pointer < (int)_w_news.size());
}

int wDalsiaNovinka() {
    if (_w_news_pointer == (int)_w_news.size())
        return 0;
    
    return _w_news[_w_news_pointer++];
}
