/**************************************/
/*      PROBOJ KSP JESEN 2011         */
/*   NAJSAMLEPSI NAJOVOCNEJSI HRAC    */
/**************************************/

#include <cstdio>
#include <cstdlib>

#define max(a, b) ( (a) > (b) ? (a) : (b) )

#define FORRANGE1(x, ma) \
    for (int x = 1; x <= (ma); x++)

extern void wPrihlasenie(const char*);
extern int wMojeID();

extern int wPocetKrajin();
extern int wPocetMojichKrajin();
extern int wDalsiaMojaKrajina();

extern int wPeniaze();
extern int wSusedia(int krajinaA, int krajinaB);

extern int wHornatost(int krajina);
extern int wProsperita(int krajina);
extern int wMajitel(int krajina);
extern int wVojsko(int krajina);

extern bool wNajmi(int kde, int kolko);
extern void wNeutoc();
extern bool wZautoc(int odkial, int kam, int kolko);

extern bool wSuNovinky();
extern int wDalsiaNovinka();

// -------------------------------------------------------

FILE* debugf;

// TODO cela tato fcia sa ma ucit
// a TODO spytat sa sysla
double usefulness(int k) {
    int OKOLIE_SCALE = wVojsko(k) + wPeniaze(); // ako velmi mi je jedno ci je na okoli vela nepriatelov
    int pSusedov = 0, pNepriatelov = 0;
    int potencialnyZisk = 0, potencialnaOhrozenost = 0;
    FORRANGE1(s, wPocetKrajin()) // prelez vsetkych susedov
        if (wSusedia(k, s)) {
            pSusedov++;
            if (wMajitel(s) != wMojeID()) {
                pNepriatelov++;
                potencialnyZisk = max(potencialnyZisk, wProsperita(s));
                potencialnaOhrozenost = max(potencialnaOhrozenost, wVojsko(s));
            }
        }

    double coolness = potencialnyZisk;
    double bezpecnost = (OKOLIE_SCALE - potencialnaOhrozenost*(pNepriatelov/pSusedov) + 0.2*wHornatost(k) * OKOLIE_SCALE);

    //fprintf(debugf, "        wProsperita: %d, ", wProsperita(k));
    //fprintf(debugf, "        coolness/bezpecnost: %f\n", coolness/bezpecnost);
    return wProsperita(k) + coolness/bezpecnost - ( wMajitel(k) == 0 ? 1 : 0 );
}

bool naHraniciach(int k) {
    bool res = false;
    FORRANGE1(s, wPocetKrajin()) if (wSusedia(k, s))
        res |= (wMajitel(s) != wMojeID());
    return res;
}

// TODO ked ma niekto prepadne, chcem sa o to znovu bit?
int main() {
    wPrihlasenie("Aristarchos z U$amu");
    fflush(stdout);
    debugf = fopen("debug", "w");

    // nekonstantne ale konstanty {{{

    double RISK_FACTOR = 0.15; // TODO uc sa
    double DEFENSIVE_TILL = 0.35; // kedy sa switchne z defenzivnej strategie

    // }}}

    int kolo = 0;
    while (1) {
        kolo++;
        // prejdem vsetkych susedov vsetkych nasich krajin a daco tam {{{
        int maxzisk = -1, source = 0, target = 0;
        FORRANGE1(k, wPocetKrajin()) if (wMajitel(k) == wMojeID())
            FORRANGE1(s, wPocetKrajin())
                if (wSusedia(k, s) && wMajitel(s) != wMojeID()) {
                    double targetSila = wVojsko(s) * ((1.25 - RISK_FACTOR) + 0.2*wHornatost(s));
                    double nasaSila = (wVojsko(k)+wPeniaze()) * (0.75 + RISK_FACTOR);
                    //fprintf(debugf, "        riesim krajinu %d\n", k);
                    //fprintf(debugf, "        nasa sila: %f, targetSila: %f\n", nasaSila, targetSila);
                    if (nasaSila > 2 * targetSila && usefulness(s) > maxzisk) {
                        maxzisk = usefulness(s);
                        source = k;
                        target = s;
                    }
                }

        if (maxzisk != -1) {
            double targetSila = 1+wVojsko(target) * ((1.25 - RISK_FACTOR) + 0.2*wHornatost(target));
            int vojakov = 1.7 * targetSila + wVojsko(target);
            wNajmi(source, vojakov - wVojsko(source));
        }

        if (double(wPocetMojichKrajin())/double(wPocetKrajin()) < DEFENSIVE_TILL) {
            //fprintf(debugf, "");

            int counter = 0;
            while (wPeniaze()) {
                if (++counter > 100) break;
                int k = wDalsiaMojaKrajina();
                if (!naHraniciach(k))
                    wNajmi(k, 1);
            }
        }

        if (maxzisk == -1) {
            fprintf(debugf, "kolo %3d: neutocim\n", kolo);
            int sem = 0;
            FORRANGE1(_, wPocetMojichKrajin()) {
                int k = wDalsiaMojaKrajina();
                if (naHraniciach(k)) {
                    sem = k;
                    break;
                }
            }
            int odtialto = 0;
            FORRANGE1(_, wPocetMojichKrajin()) {
                int k = wDalsiaMojaKrajina();
                if (!naHraniciach(k)) {
                    odtialto = k;
                    break;
                }
            }
            fprintf(debugf, "kolo %3d: presuvam z %d na %d\n", kolo, odtialto, sem);
            wZautoc(odtialto, sem, wVojsko(odtialto));
        }
        else {
            fprintf(debugf, "kolo %3d: utocim na %d\n", kolo, target);
            wZautoc(source, target, wVojsko(source)*0.7);
        }
        // }}}

        fprintf(debugf, "kolo %3d: zijem!", kolo);
        fflush(debugf);
    }

    fclose(debugf);
    return 0;
}
