#include <vector>
#include <algorithm>
#include <string>
#include <sstream>
#include <cmath>
#include <iomanip>

#include "inc.h"




using namespace std;

vector<int> toInt (vector<bool> pole){
    vector<int> result;
    for (int i=0; i<(int)pole.size(); i++)
        if(pole[i]==1) result.push_back(i);

    return result;
}
string Krajina::toString(){
    ostringstream oss;
    oss.precision(2);
    oss << "Krajina {ID = " << setw(2)<< ID << "; hornatost = " << setw(2)<< hornatost << "; income = " << setw(2)<< income;
    oss << "; army = "<< setw(3) << army << "; owner = " << setw(1)<< owner << "; bezp = " << setw(5)<<fixed<< bezpec <<  "; obrana = " << fixed << setw(5)<< obrana ;
    oss <<"; defpot = "<< setw(5)<< fixed<< defpot  <<  "; ofpot = " << setw(5)<< fixed<< ofpot  << "; NaturalImp = "<< setw(5)<< fixed<< naturalImp << "; exppot = ";
    oss << exppot <<"; imporatancia = "<< setw(5) << fixed << importancia << "; bezSus = "<< fixed << setw(4) << bezSus<< "; Susedia [ ";

    for (int i=0; i<(int) susedia.size(); i++) oss << susedia[i]<<" ";

    oss << "]"  << " }" << endl;

    return oss.str();
}
string Owner::toString(){
    ostringstream oss;
    oss.precision(2);
    oss << "Owner {ID = " << setw(2) << ID << "; importancia = "<< setw(5) << fixed << importancia <<"; income = " << income << "; money = " << money << "; Krajiny [ ";

    for (int i=0; i<(int) krajiny.size(); i++) oss << krajiny[i]<<" ";
    oss << "] }" << endl;
    return oss.str();
}
/*string Novinka::toString(){
    ostringstream oss;
    oss << "Novinka {krajina = "<<setw(2) << krajina << "; type = " << type << "; pNajatych = " <<setw(3)<< pNajatych <<  "; pAttackers = ";
    oss << setw(3)<< pAttackers << "; target = "<< setw(2) << target << "; prezilo = "<< setw(3) << prezilo << "; result = " << result << "}" << endl;
    return oss.str();
}*/

// <include>

extern void wPrihlasenie(const char*);
extern int wMojeID();

extern int wPocetKrajin();
extern int wPocetMojichKrajin();
extern int wDalsiaMojaKrajina();

extern int wPeniaze ();
extern int wSusedia (int KrajinaA, int KrajinaB);

extern int wHornatost(int krajina);
extern int wProsperita(int krajina);
extern int wMajitel(int krajina);
extern int wVojsko(int krajina);
//extern int wPeniazeHraca(int hrac);


extern bool wNajmi (int kde, int kolko);
extern void wNeutoc();
extern bool wZautoc(int odkial, int kam, int kolko);

extern bool wSuNovinky ();
extern int wDalsiaNovinka();

//extern class Novinka;

//extern bool wSuNaozajNovinky();
//extern Novinka wDalsiaNaozajNovinka();

// </include>

// nacitavanie v pohode
void nacitajMapu ();
void nacitajStatusKrajin(vector<Krajina>& kraj, vector<Owner>& owner,bool Kuko);
void nacitajStatusOwner();
void nacitajStatusNovinka();

bool pHornatost (Krajina a, Krajina b);         //works
bool pArmy      (Krajina a, Krajina b);         //works
bool pOwner     (Krajina a, Krajina b);         //works
bool pIncome    (Krajina a, Krajina b);         //works
bool pObrana    (Krajina a, Krajina b);         //works


//------------------VITAJTE V BULHARSKU--------------------------------------------------
const float ImpOfSus=0.17 , Verbing=0.4 , EPW=0.2 , BSW=0.2;
//----------pre NIK---

//------------------DOVIDENIA V BULHARSKU---------------------------------------
fstream out;
vector <int> susediaMojichKrajin ();

vector <Krajina> findByOwner(int owner);
vector <Krajina> getKrajinaById(vector <int> ids);

int ownersIncome (int owner);


vector<vector<int> > mapa;
vector<Krajina> kraj;
vector<Owner> owner;
//vector<Novinka> novinky;
int tah=0, money;


void debug(string name, vector <Krajina> x){
    out << "____ "<< name << " ___________________" << endl;
    for (int i=0; i<(int)  x.size(); i++) out <<   x[i].toString();
}
/*void debug(string name, vector <Novinka> x){
    out<< "____ "<< name << " ___________________" << endl;
    for (int i=0; i<(int)  x.size(); i++) out <<   x[i].toString();
}*/
void debug(string name, vector   <Owner> x){
    out << "____ "<< name << " ___________________" << endl;
    for (int i=0; i<(int)  x.size(); i++) out <<   x[i].toString();
}

void SimulFight(Krajina Source,Krajina Targ,int Army,vector<Owner>& PotOwn, vector<Krajina>& PotMap)
{
    if(Source.owner == Targ.owner)
    {
        PotMap[Targ.ID].army+=Army;
        PotMap[Source.ID].army-=Army;
    }
    else
    {
        float Def=Targ.army,Att=Army,t=0.01;
        while(Att>0 && Def >0)
        {
            float pom=Att;
            Att-=t*sqrt(Def);
            Def-=t*sqrt(pom)*pow(0.8,Targ.hornatost);
        }
        if(Att>1.2)
        {
            PotMap[Targ.ID].owner=PotMap[Source.ID].owner;
            PotMap[Targ.ID].army=(int)Att;
            PotOwn[Targ.owner].income-=Targ.income;
            PotOwn[Source.owner].income+=Targ.income;
        }
        else
        {
            PotMap[Targ.ID].army=(int)Def;
        }
    }
}

int main (){

    wPrihlasenie("Racionalne pi");
    out.open("debug",fstream::out|fstream::trunc);

    nacitajMapu();

    while(true){

        out << "____ Tah " << tah << " _________________" << endl;

        for (int i=0; i<6; i++)
            owner[i].income = ownersIncome(i);

        nacitajStatusKrajin(kraj, owner, 1);
        debug("Krajiny", kraj);

        nacitajStatusOwner();
        debug("Owners", owner);

//        nacitajStatusNovinka();
//        debug("Novinky", novinky);

        vector<Krajina> zaut   = getKrajinaById(susediaMojichKrajin());
        vector<Krajina> PotMap = kraj;
        vector<  Owner> PotOwn = owner;
        vector<Krajina> moje   = getKrajinaById(owner[3].krajiny);

        double MaxRat=0,rat;
        Krajina AttTarg, Source;
        int AttArm=0;
        float Imps[6]={0,0,0,0,0,0};

        for(int i=0; i< (int)moje.size(); i++)
        {
            for(int j=0; j< (int)moje[i].susedia.size(); j++)
            {
                Krajina sus = kraj[moje[i].susedia[j]];
                SimulFight(moje[i],sus,moje[i].army,PotOwn,PotMap);
                nacitajStatusKrajin(PotMap, PotOwn, 0);

                for(int k=0; k<(int)PotMap.size(); k++)
                {
                    Imps[PotMap[k].owner]+=PotMap[k].importancia;
                }

                float maximp=0.01;
                for(int k=0; k<6; k++)
                {
                    if(k==3)continue;
                    maximp= max(Imps[k], maximp);
                }
                rat= Imps[3]/maximp;
                if(rat > MaxRat)
                {
                    MaxRat = rat;
                    Source = moje[i];
                    AttTarg = sus;
                    AttArm = moje[i].army;
                }
                PotMap[moje[i].ID]=kraj[moje[i].ID];
                PotMap[moje[i].susedia[j]]=kraj[moje[i].susedia[j]];
            }
        }
        out << "Ahoj" << endl;
        out.flush();
        SimulFight(Source,AttTarg,AttArm,PotOwn,PotMap);
        out << "caw"<<endl;
        out.flush();
        for(int i=wPeniaze(); i>0; i--)
        {
            out << i << endl;
            out.flush();
            float maximp=0;
            int best=0,B=0;
            for(int j=0; j<(int)moje.size(); j++)
            {
                out << "dac"<< endl;
                out.flush();

                PotMap[moje[j].ID].army++;


            /*for (int i=0; i<6; i++)
                owner[i].income = ownersIncome(i);*/

                nacitajStatusKrajin(PotMap, PotOwn, 0);

                out << "kuko" << endl;
                out.flush();

                float MyImp=0;
                for(int k=0; k<(int) moje.size(); k++) {
                    out << k << endl;
                    out.flush();

                    MyImp += PotMap[moje[k].ID].importancia;
                }

                out << "fodo" << endl;
                out.flush();

                if(PotMap[AttTarg.ID].owner == 3) MyImp += PotMap[AttTarg.ID].importancia;
                out << "fork" << endl;
                out.flush();
                if(MyImp > maximp)
                {
                    out.flush();
                    maximp = MyImp;
                    best = moje[j].ID;
                    B=best;
                }
                PotMap[moje[j].ID].army--;
            }
            out << "Nieco" << endl;
            out.flush();

            int x =0;

            out << x++ << endl;
            out.flush();

            if(PotMap[AttTarg.ID].owner == 3)
            {
                PotMap[AttTarg.ID].army++;
                nacitajStatusKrajin(PotMap, PotOwn, 0);
                float MyImp=0;
                for(int k=0; k<(int)moje.size(); k++) MyImp += PotMap[moje[k].ID].importancia;
                MyImp += PotMap[AttTarg.ID].importancia;
                if(MyImp > maximp)
                {
                    maximp = MyImp;
                    best = Source.ID;
                    AttArm ++;
                    B = AttTarg.ID;
                }
                PotMap[AttTarg.ID].army--;
            }
            out << best+1 << endl;
            out.flush();
            wNajmi(best + 1, 1);

            PotMap[B].army++;
        }

        /*vector<Krajina> zaut = getKrajinaById(susediaMojichKrajin());
        sort(zaut.begin(),zaut.end(),pObrana);
        debug("Susedia", zaut);

        vector<Krajina> utok = getKrajinaById(zaut[0].susedia);
        sort(zaut.begin(),zaut.end(),pArmy);
        debug("Mozny utok", utok);

        int ID=0;
        for (int i=(int)utok.size()-1; i>-1; i--){
            if ( utok[i].owner==wMojeID()) {
                ID = utok[i].ID;
                break;
            }
        }


        wNajmi(ID+1,wPeniaze());
        int pocet = kraj[ID].army *3/4;

        vector <Krajina> dosah = getKrajinaById(kraj[ID].susedia);

        for (int i=0; i<(int) dosah.size(); i++){
            if ((dosah[i].ID!=zaut[0].ID) && ((dosah[i].owner ==3))) pocet = kraj[ID].army;
        }



        if (zaut[0].obrana*1.10<pocet){
            wZautoc(ID+1, zaut[0].ID+1, pocet);
        }
        else wNeutoc();
        */
        out << Source.ID << "   " << AttTarg.ID << "  " << AttArm<< endl;
        out.flush();
        wZautoc(Source.ID+1,AttTarg.ID+1,AttArm);
        tah++;
    }
}





void nacitajMapu(){
    int velkost = wPocetKrajin();

    mapa.resize(velkost);
    kraj.resize(velkost);
    owner.resize(6);

    for(int i=0; i<velkost; i++) {
        mapa[i].resize(velkost);


        for(int j=0; j<velkost; j++){
            mapa[i][j]=wSusedia(i+1,j+1);
        }

        kraj[i].ID=i;
        kraj[i].hornatost=wHornatost(i+1);
        kraj[i].income=wProsperita(i+1);
        kraj[i].naturalImp = pow(1.25,kraj[i].hornatost) * kraj[i].income;
    }

    for (int i=0; i<wPocetKrajin(); i++){
        for(int j=0; j<wPocetKrajin(); j++){
            if (mapa[i][j]==1) kraj[i].susedia.push_back(j);
        }
    }


// debug

    out << "_____ Matica susednosti ____________________________" << endl;

    for (int i=0; i<(int) mapa.size(); i++){
        for (int j=0; j<(int) mapa.size(); j++){
            out << mapa[i][j];
        }
        out << endl;
    }
    long int suma;
    vector <float> pom(velkost,0);
    for(int i=0;i<5;i++)
    {
        for(int j=0;j<(int)velkost;j++)
        {
            suma=0;
            for(int k=0; k<(int)kraj[j].susedia.size(); k++)  suma += kraj[kraj[j].susedia[k]].naturalImp;
            pom[j]=suma;
        }
        for(int j=0; j<velkost; j++)
        {
            kraj[j].naturalImp *= (1-ImpOfSus);
            kraj[j].naturalImp += pom[j]*ImpOfSus/kraj[j].susedia.size();
        }
    }


}
void nacitajStatusKrajin(vector<Krajina>& kraj, vector<Owner>& owner, bool Kuko) {
    for (int i=0; i<(int) mapa.size(); i++){
        if(Kuko)
        {
            kraj[i].owner=wMajitel(i+1);
            kraj[i].army=wVojsko(i+1);
        }
        kraj[i].obrana = kraj[i].army * pow(1.25,kraj[i].hornatost);
        if(kraj[i].owner != 0)
        {
            kraj[i].ofpot=kraj[i].army + (owner[kraj[i].owner].income + 0) * Verbing;
            kraj[i].defpot = kraj[i].ofpot * pow(1.25,kraj[i].hornatost);
        }
        else
        {
            kraj[i].ofpot=0;
            kraj[i].defpot = kraj[i].obrana;
        }
    }
    int poc=0;
    float AvEnOfP,ofsum=0;
    for (int i=0; i<(int) mapa.size(); i++)
    {
        if(kraj[i].owner!=3)
        {
            poc++;
            ofsum+=kraj[i].ofpot;
        }
    }
    AvEnOfP=ofsum/poc;
    for (int i=0; i<(int) mapa.size(); i++)
    {
        int sus;
        float ofmax=0, sum=0, ofp;
        kraj[i].bezSus=0;
        for (int j=0; j<(int) kraj[i].susedia.size();j++)
        {
            sus=kraj[i].susedia[j];
            if(kraj[sus].owner == kraj[i].owner)
            {
                kraj[i].bezSus += kraj[sus].naturalImp*AvEnOfP/(AvEnOfP + kraj[sus].defpot);
            }
            else
            {
                ofp = kraj[sus].ofpot;
                ofmax = ofp > ofmax ? ofp : ofmax;
                sum += kraj[sus].naturalImp * (kraj[i].ofpot/(kraj[i].ofpot + kraj[sus].defpot));
            }
        }
        if (ofmax==0) kraj[i].bezpec=1;
        else kraj[i].bezpec = kraj[i].obrana/(kraj[i].obrana + ofmax);
        kraj[i].exppot = sum;
        kraj[i].importancia = (kraj[i].naturalImp + kraj[i].exppot * EPW) * (kraj[i].bezpec + kraj[i].bezSus * BSW);
    }
}
void nacitajStatusOwner(){
    for (int i=0; i<6; i++){

        owner[i].ID = i;
//        owner[i].money = wPeniazeHraca(i);
        owner[i].income = ownersIncome(i);
        vector <Krajina> help = findByOwner(i);
        owner[i].krajiny.clear();
        for (int j=0; j<(int) help.size(); j++) owner[i].krajiny.push_back(help[j].ID);
        owner[i].importancia=0;
        for(int j=0; j< (int)owner[i].krajiny.size(); j++) owner[i].importancia += kraj[owner[i].krajiny[j]].importancia;


    }
}
/*void nacitajStatusNovinka(){
    novinky.clear();
    while(wSuNaozajNovinky())
        novinky.push_back(wDalsiaNaozajNovinka());
}*/
bool pHornatost (Krajina a, Krajina b){
    return a.hornatost < b.hornatost;
}
bool pArmy (Krajina a, Krajina b){
    return a.army < b.army;
}
bool pOwner (Krajina a, Krajina b){
    return a.owner < b.owner;
}
bool pIncome (Krajina a, Krajina b){
    return a.income < b.income;
}
bool pObrana (Krajina a, Krajina b){
    return a.obrana < b.obrana;
}
vector<Krajina> findByOwner(int owner){
    vector <Krajina> result;
    for (int i=0; i<wPocetKrajin(); i++)
        if (kraj[i].owner == owner) result.push_back(kraj[i]);
    return result;
}
vector <Krajina> getKrajinaById(vector <int> ids){
    vector <Krajina> result;
    for (int i=0; i<(int)ids.size(); i++)
        result.push_back(kraj[ids[i]]);

    return result;
}
int ownersIncome (int owner){
    vector<Krajina> krajinyOwner = findByOwner(owner);
    int result = 0;
    for (int i=0; i<(int) krajinyOwner.size(); i++) result+=krajinyOwner[i].income;
    return result;
}
vector <int> susediaMojichKrajin(){
    vector <bool> temp;
    temp.resize(wPocetKrajin());

    for (int i=0; i<wPocetMojichKrajin(); i++){
        int x = wDalsiaMojaKrajina()-1;
        for(int j=0; j<(int)kraj[x].susedia.size(); j++){
            if (kraj[kraj[x].susedia[j]].owner!=wMojeID()) temp[kraj[x].susedia[j]]=1;
        }
    }
    return toInt(temp);
}
